Subject: [bitcoindev] Re: Multi-byte opcodes

From: Garlo Nicon <[email-masked]>
Date: Mon, 18 Nov 2024 07:10:16 -0800 (PST)

> I think we need a way to allow more opcodes without taking up the rest of 
the NOPs.

It is already possible since Taproot. For example: OP_CHECKSIGADD was 
added, without replacing any OP_NOP.

> I feel that someone must have brought this up before (but it is a little 
bit hard to find the history in this mailing list at this moment).

Satoshi added OP_SINGLEBYTE_END, set to 0xf0, and OP_DOUBLEBYTE_BEGIN, set 
to 0xf000. It was removed later, but it can be reintroduced in a similar 
way, if needed. See source code for version 0.1.0 for more details.

sobota, 16 listopada 2024 o 03:00:53 UTC+1 Weikeng Chen napisał(a):

> I think we need a way to allow more opcodes without taking up the rest of 
> the NOPs.
>
> This is related to a point from Murch (
> https://groups.google.com/g/bitcoindev/c/usHmnXDuJQc/m/hhtvAjSdCgAJ) that 
> the reasoning of "its' compatible, why not" for adding 
> CHECKSIGFROMSTACK(VERIFY/ADD) is not solid because when we add a new 
> opcode, we usually have to give up a NOP. We do not have many NOPs left.
>
> We can, however, solve that by allowing multi-byte opcodes.
>
> Say, for example, we can have:
>     OP_OP { 0x1521 }
> which will set the current opcode to be the one with the assigned number 
> 0x1521.
>
> Another idea is maybe OP_OP takes a stack element as the opcode.
>     { 0x1521 } OP_OP
>
> We can enforce some sort of minimal rule, or not do so, to allow more 
> flexible use of existing opcodes.
>
> This, of course, runs at a cost as this opcode needs three bytes in total 
> to represent, but since the existing opcodes already take care of most of 
> the basic functionalities that we expect users to use very frequently, the 
> new opcodes that we want to add are likely those that complete something 
> important and are going to be used only a few times in a script.
>
> Similarly, we can require that multi-byte opcodes that have not been 
> enabled my result in OP_SUCCESS.
>
> OP_OP is not the best name as it could be confusing. OP_SETOP, OP_NEXT, 
> etc could be taken into consideration.
>
> The result of this is that we can worry less about whether it is worthy of 
> a NOP to do an opcode, but focus on if the opcode has enough use cases to 
> support it.
>
> I feel that someone must have brought this up before (but it is a little 
> bit hard to find the history in this mailing list at this moment).
>
> What do people think?
>
> Thanks,
> Weikeng
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/3b2707fe-0ddd-4c1a-8167-fccef47a9d2en%40googlegroups.com.